﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/
package {
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.events.Event;
	import flash.ui.Keyboard;
	
	public class Main extends MovieClip {
		public static const PADDLE_SPEED:int = 6;
		private var wait:int;
		private var scoreLeft:int;
		private var scoreRight:int;
		private var particles:MovieClip;
		private var nextEmit:int;
		private var emitEvery:int;
		private var emitAtOnce:int;
		private var ki:Boolean;
		public function Main():void {
		}
		
		public function init():void {
			Key.init(stage);
			scoreLeft=0;
			txtLeft.text = ""+scoreLeft;
			scoreRight=0;
			txtRight.text = ""+scoreRight;
			wait=50;
			emitEvery=0;
			emitAtOnce=1;
			nextEmit=0;
			ki=true;
			ball.alpha=.7;
			ball.addEventListener(BallEvent.SCORED, scoredHandler);
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			particles = new MovieClip();
			addChildAt(particles,1);
		}
		
		private function scoredHandler(e:BallEvent):void {
			if (e.player==0) {
				scoreRight++;
				txtRight.text = ""+scoreRight;
			} else {
				scoreLeft++;
				txtLeft.text=""+scoreLeft;
			}
			ball.x = stage.stageWidth/2;
			ball.y = stage.stageHeight/2;
			ball.ballSpeed = 5;
			wait=50;
		}
		
		public function enterFrameHandler(e:Event):void {
			// animate particles
			for (var i:int=0;i<particles.numChildren;i++) {
				var p:Particle = Particle(particles.getChildAt(i));
				if (p.isAlive()) p.animate();
				else particles.removeChild(p);
			}
			if (wait>0) {
				wait--;
				return;
			}
			movePaddles();
			ball.checkPaddleCollision(paddleLeft);
			ball.checkPaddleCollision(paddleRight);
			ball.move();
			// particle stuff
			nextEmit--;
			if (nextEmit<=0) {
				nextEmit=emitEvery;
				for (var j:int=0;j<emitAtOnce;j++) {
					particles.addChild(new Particle(ball.rotation-10+(Math.random()*20),ball.x,ball.y));
				}
			}
		}
		
		private function movePaddles():void {
			if (Key.isDown(Keyboard.DOWN)) {
				paddleRight.y+=PADDLE_SPEED;
				if (paddleRight.y>stage.stageHeight-paddleRight.height/2) paddleRight.y = stage.stageHeight-paddleRight.height/2;
			}
			if (Key.isDown(Keyboard.UP)) {
				paddleRight.y-=PADDLE_SPEED;
				if (paddleRight.y<paddleRight.height/2) paddleRight.y = paddleRight.height/2;
			}
			if (!ki) {
				if (Key.isDown(83)) {
					paddleLeftMove(PADDLE_SPEED);
				}
				if (Key.isDown(87)) {
					paddleLeftMove(-PADDLE_SPEED);
				}
			} else {
				if (paddleLeft.y>ball.y) {
					paddleLeftMove(-PADDLE_SPEED);
				} else {
					paddleLeftMove(PADDLE_SPEED);
				}
			}
		}
		
		function paddleLeftMove(dist:Number):void {
			paddleLeft.y+=dist;
			if (paddleLeft.y>stage.stageHeight-paddleLeft.height/2) paddleLeft.y = stage.stageHeight-paddleLeft.height/2;
			if (paddleLeft.y<paddleLeft.height/2) paddleLeft.y = paddleLeft.height/2;
		}
	}
}